# ---------------------------------------------------------------------------- #

# Project: C++X
# File   : acinclude.m4
# Info   : $Id: acinclude.m4,v 1.12 2012/09/17 16:52:52 gkraeuter Exp $

# ---------------------------------------------------------------------------- #

# ---------------------------------------------------------------------------- #

# CX_CHECK_LIB([lib],[include],[body],
#             [include_path],[lib_path],[action_if_success],[action_if_failure])
# input : CX_EXTERN_C CPPFLAGS LIBS
# output: CX_CPPFLAGS CX_LIBS CX_LDFLAGS CX_MESSAGE_HEADER CX_MESSAGE_BODY
#         CX_EXTERN_C

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_CHECK_LIB],[
  _cxa_cppflags=$CPPFLAGS
  _cxa_libs=$LIBS
  CX_LIBS=
  _cxa_tmp=
  _cxa_result="builtin"
  CX_CHECK_HEADER([$2],[$4],[
    CPPFLAGS="$CPPFLAGS $CX_CPPFLAGS"
    _AS_ECHO_LOG([searching for lib$1])
    AS_ECHO_N(["searching for lib$1... "])
    for _cxa_iterator in $5 $CX_LIBRARY_PATH; do
      AS_IF([test -f "$_cxa_iterator/lib$1.so"],[
        _cxa_result=$_cxa_iterator/lib$1.so
        CX_LIBS="-L$_cxa_iterator"
        AS_IF([test "x$CX_RFLAG" != x],[
          for _cxa_iterator1 in $CX_DLSEARCH_PATH; do
            _cxa_found=no
            AS_IF([test "$_cxa_iterator1" = "$_cxa_iterator"],[
              _cxa_found=yes
              break
            ])
          done
          AS_IF([test $_cxa_found = no],[CX_LDFLAGS="$CX_RFLAG$_cxa_iterator"])
        ])
        break
      ])
    done
    LIBS="$_cxa_libs $CX_LIBS -l$1"
    AC_LINK_IFELSE([AC_LANG_PROGRAM([$_CX_INCLUDE],[$3])],[
      AC_MSG_RESULT([$_cxa_result])
      CX_LIBS="$CX_LIBS -l$1"
      _cxa_result=yes
    ],[
      LIBS="$_cxa_libs $CX_LIBS"
      AC_LINK_IFELSE([AC_LANG_PROGRAM([$_CX_INCLUDE],[$3])],[
        AC_MSG_RESULT([$_cxa_result])
        _cxa_result=yes
      ],[
        AS_IF([test $_cxa_result = builtin],[
          AC_MSG_RESULT([not found])
        ],[
          AC_MSG_RESULT([not usable])
        ])
        CX_MESSAGE_HEADER="lib$1 missing!"
        CX_MESSAGE_BODY="The library lib$1 has not been detected by configure."
        _cxa_result=no
      ])
    ])
  ],[
    CX_MESSAGE_HEADER="$_cxb_iterator missing!"
    CX_MESSAGE_BODY="The header file $_cxb_iterator, needed by lib$1 has not been detected by configure. Please check your installation and make sure you have installed the required development packages."
   _cxa_result=no
  ])
  CPPFLAGS=$_cxa_cppflags
  LIBS=$_cxa_libs
  AS_IF([test $_cxa_result = yes],[$6],[$7])
])


# ---------------------------------------------------------------------------- #

# CX_CHECK_HEADER([include],[include_path],[action_if_success],
#                 [action_if_failure]
# output: CX_CPPFLAGS

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_CHECK_HEADER],[
  _cxb_save_cppflags=$CPPFLAGS
  CX_CPPFLAGS=
  _CX_INCLUDE=
  CX_EXTERN_C=no
  for _cxb_iterator in $1; do
    _cxb_result=builtin
    _AS_ECHO_LOG([searching for $_cxb_iterator])
    AS_ECHO_N(["searching for $_cxb_iterator... "])
    for _cxb_dir in $2 $CX_INCLUDE_PATH; do
      AS_IF([test -f "$_cxb_dir/$_cxb_iterator"],[
        _cxb_result=$_cxb_dir/$_cxb_iterator
        CX_ADD([CX_CPPFLAGS],[-I$_cxb_dir])
        break;
      ])
    done
    _cxb_extern_c=no
    AS_IF([test "$_cxb_result" != builtin],[
      AS_IF([test x$_cxb_iterator = xgif_lib.h],[
        AS_IF([test x"$($GREP __cplusplus $_cxb_result)" = x],[
          _cxb_extern_c=yes
        ])
      ],[test x$_cxb_iterator = xjpeglib.h],[
        AS_IF([test x"$($GREP __cplusplus $_cxb_result)" = x],[
          _cxb_extern_c=yes
        ])
      ])
    ])
    AS_IF([test $_cxb_extern_c = yes],[
      CX_EXTERN_C=yes
      _CX_INCLUDE="$_CX_INCLUDE$as_nl#ifdef __cplusplus$as_nl#extern \"C\" {$as_nl#include <$_cxb_iterator>$as_nl#endif$as_nl#ifdef __cplusplus$as_nl}$as_nl#endif"
    ],[
      _CX_INCLUDE="$_CX_INCLUDE$as_nl#include <$_cxb_iterator>"
    ])  
    CPPFLAGS="$CPPFLAGS $CX_CPPFLAGS"
    AC_COMPILE_IFELSE([AC_LANG_PROGRAM([$_CX_INCLUDE])],[
      AC_MSG_RESULT([$_cxb_result])
      _cxb_result=yes
    ],[
      AS_IF([test $_cxb_result = builtin],[
        AC_MSG_RESULT([not found])
      ],[test $_cxb_result = yes],[
        AC_MSG_RESULT([no])
      ],[
        AC_MSG_RESULT([not usable])
      ])
      _cxb_result=no
      break
    ])
  done
  CPPFLAGS=$_cxb_save_cppflags
  AS_IF([test $_cxb_result = yes],[$3],[$4])
])

# ---------------------------------------------------------------------------- #

# CX_ERROR_MESSAGE([msg_header],[msg_body])

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_ERROR_MESSAGE],[
  AS_IF([test -z $1],[
    _cxc_header=$CX_MESSAGE_HEADER
  ],[
    _cxc_header=$1
  ])
  AS_IF([test -z $2],[
    _cxc_body=$CX_MESSAGE_BODY
  ],[
    _cxc_body=$2
  ])
  _cxc_line1="+------------------------------------------------------------------------------+$as_nl"
  _cxc_line2="|                                                                              |$as_nl"
  _cxc_line3=$_cxc_header
  _cxc_line4=
  while test $(expr -- "$_cxc_line3" : '.*') -lt 75; do
    _cxc_line3=" $_cxc_line3 "
  done
  if test $(expr -- "$_cxc_line3" : '.*') = 75; then
    _cxc_line3=" $_cxc_line3"
  fi
  _cxc_line3="| $_cxc_line3 |$as_nl"
  _cxc_block=$_cxc_body
  _cxc_line=
  while test $(expr -- "$_cxc_block" : '.*') -gt 76; do
    _cxc_line=$_cxc_block
    while test $(expr -- "$_cxc_line" : '.*') -gt 76; do
      _cxc_line=$(expr "$_cxc_line" : '\(.*\) ')
    done
    _cxc_block=$(expr "$_cxc_block" : "$_cxc_line \(.*\)")
    _cxc_tmp=
    while test $(expr -- "$_cxc_line" : '.*') -lt 76; do
      _cxc_tmp=$(expr "$_cxc_line" : ".*\( .*$_cxc_tmp\)")
      _cxc_line=$(expr "$_cxc_line" : "\(.*\)$_cxc_tmp")
      _cxc_tmp=" $_cxc_tmp"
      _cxc_line=$_cxc_line$_cxc_tmp
    done
    _cxc_line4="$_cxc_line4| $_cxc_line |$as_nl"
  done
  while test $(expr -- "$_cxc_block" : '.*') -lt 76; do
    _cxc_block="$_cxc_block "
  done
  _cxc_line4="$_cxc_line4| $_cxc_block |$as_nl"

  AC_MSG_ERROR([$as_nl$as_nl$_cxc_line1$_cxc_line3$_cxc_line1$_cxc_line2$_cxc_line4$_cxc_line2$_cxc_line1])
])

# ---------------------------------------------------------------------------- #

# CX_ADD([flag],[value])

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_ADD],[
  _cxe_in=`eval echo \$$1`
  for _cxe_iter1 in $2; do
    _cxe_found=no
    for _cxe_iter2 in $_cxe_in; do
      AS_IF([test x$_cxe_iter1 = x$_cxe_iter2],[
        _cxe_found=yes
        break;
      ])
    done
    AS_IF([test $_cxe_found = no],[
      _cxe_in="$_cxe_in $_cxe_iter1"
    ])
  done
  $1=$_cxe_in
])
 
# ---------------------------------------------------------------------------- #

# CX_ADD_OPTION([option],[value])
# output CX_OPTION

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_ADD_OPTION],[
  _cxf_line1="+------------------------------------------------------------------------------+$as_nl"
  AS_IF([test -z "$CX_OPTION"],[
    CX_OPTION="$_cxf_line1| "
    _cxf_line2="$PACKAGE_STRING successfully configured"
    while test $(expr -- "$_cxf_line2" : ".*") -lt 76; do
      _cxf_line2="$_cxf_line2 "
    done
    CX_OPTION="$CX_OPTION$_cxf_line2 |$as_nl| "
    _cxf_line2="with the following options:"
    while test $(expr -- "$_cxf_line2" : ".*") -lt 76; do
      _cxf_line2="$_cxf_line2 "
    done
    CX_OPTION="$CX_OPTION$_cxf_line2 |$as_nl$_cxf_line1"
  ])
  _cxf_line2="| $1"
  while test $(expr -- "$_cxf_line2" : '.*') -lt 26; do
    _cxf_line2="$_cxf_line2 "
  done
  _cxf_line2="$_cxf_line2:  $2"
  while test $(expr -- "$_cxf_line2" : '.*') -lt 78; do
    _cxf_line2="$_cxf_line2 "
  done
  CX_OPTION="$CX_OPTION$_cxf_line2 |$as_nl"
])

# ---------------------------------------------------------------------------- #

# CX_OUTPUT

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_OUTPUT],[
  CXXX_FEATURES="/*----------------------------------------------------------------------------$as_nl  Project: cxxx <http://cxplorer.sourceforge.net>$as_nl  File   : CxxxFeatures.h$as_nl----------------------------------------------------------------------------*/$as_nl$as_nl/*              This file has been autogenerated by configure.              */$as_nl$as_nl#ifndef CxxxFeatures_h$as_nl#define CxxxFeatures_h$as_nl$CXXX_FEATURES$as_nl// The version of this library$as_nl#define CXXX_VERSION \"$libcxxx_version\""
  AS_IF([test "$CXXX_FEATURES_CXXX"],[
    CXXX_FEATURES="$CXXX_FEATURES$as_nl$as_nl""namespace cxxx$as_nl{$CXXX_FEATURES_CXXX}"
  ])
  AS_IF([test "$CXXX_FEATURES_STD"],[
    CXXX_FEATURES="$CXXX_FEATURES$as_nl$as_nl""namespace std$as_nl{$CXXX_FEATURES_STD}"
  ])
  CXXX_FEATURES="$CXXX_FEATURES$as_nl$as_nl#endif // CxxxFeatures_h$as_nl"
  AC_MSG_NOTICE([creating cxxx/CxxxFeatures.h])
  _cxg_features="`cat cxxx/CxxxFeatures.h 2> /dev/null`"
  AS_IF([test "$CXXX_FEATURES" = "$_cxg_features$as_nl"],[
    AC_MSG_NOTICE([cxxx/CxxxFeatures.h is unchanged])
  ],[
    echo "$CXXX_FEATURES" > cxxx/CxxxFeatures.h
  ])
  AC_MSG_NOTICE([$as_nl$CX_OPTION+------------------------------------------------------------------------------+$as_nl$as_nl Report bugs to $PACKAGE_BUGREPORT$as_nl Run 'make' to build the application.$as_nl As root run 'make install' to install it.$as_nl])
])

# ---------------------------------------------------------------------------- #

# CX_ADD_FEATURE([comment],[text],[category])

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_ADD_FEATURE],[
  AS_IF([test "$1"],[
   _cxh_text="$as_nl/* $1 */$as_nl""$2$as_nl"
  ],[
   _cxh_text="$as_nl""$2$as_nl"
  ])
  case "$3" in
  CXXX)
    CXXX_FEATURES_CXXX="$CXXX_FEATURES_CXXX$_cxh_text";;
  STD)
    CXXX_FEATURES_STD="$CXXX_FEATURES_STD$_cxh_text";;
  *)
    CXXX_FEATURES="$CXXX_FEATURES$_cxh_text";;
  esac
])

# ---------------------------------------------------------------------------- #

# CX_PUSH_VARS

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_PUSH_VARS],[
  _cxi_cppflags=$CPPFLAGS
  _cxi_cflags=$CFLAGS
  _cxi_cxxflags=$CXXFLAGS
  _cxi_libs=$LIBS
  _cxi_ldflags=$LDFLAGS
])

# ---------------------------------------------------------------------------- #

# CX_PULL_VARS

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_PULL_VARS],[
  CPPFLAGS=$_cxi_cppflags
  CFLAGS=$_cxi_cflags
  CXXFLAGS=$_cxi_cxxflags
  LIBS=$_cxi_libs
  LDFLAGS=$_cxi_ldflags
])

# ---------------------------------------------------------------------------- #

# CX_TRY_RUN([include],[body],[action_if_success],[action_if_failure])

# input : CPPFLAGS LIBS

# ---------------------------------------------------------------------------- #
AC_DEFUN([CX_TRY_RUN],[
  for _cxj_iterator in $1; do
    _cxj_include="$_cxj_include#include <$_cxj_iterator>$as_nl"
  done
  AC_RUN_IFELSE([AC_LANG_PROGRAM([$_cxj_include],[$2])],[$3],[$4])
])

# ---------------------------------------------------------------------------- #

# CX_INIT
# output: CX_INCLUDE_PATH CX_LIBRARY_PATH CX_LIBDIR CX_DATADIR CX_LOCALEDIR
#         CX_RFLAG CX_RFLAGLIBDIR CX_DLSEARCH_PATH
# input : CX_INCLUDE_PATH CX_LIBRARY_PATH

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_INIT],[
  AS_IF([test -z "$sys_lib_dlsearch_path_spec"],[
    AC_MSG_ERROR([sys_lib_dlsearch_path_spec not set])
  ])
  _cxk_tmp=$CX_INCLUDE_PATH
  CX_INCLUDE_PATH=
  for _cxk_iterator in $_cxk_tmp /usr/local/include /usr/include /include; do
    AS_IF([test -d $_cxk_iterator],[CX_ADD([CX_INCLUDE_PATH],[$_cxk_iterator])])
  done
  _cxk_tmp=$CX_LIBRARY_PATH
  CX_LIBRARY_PATH=
  for _cxk_iterator in $_cxk_tmp /usr/local/lib /usr/local/lib64 /usr/lib /usr/lib64 /lib /lib64 $sys_lib_dlsearch_path_spec; do
    AS_IF([test -d $_cxk_iterator],[CX_ADD([CX_LIBRARY_PATH],[$_cxk_iterator])])
  done
  AS_IF([test "x$prefix" = xNONE],[prefix=$ac_default_prefix])
  AS_IF([test "x$exec_prefix" = xNONE],[exec_prefix='${prefix}'])
  CX_LIBDIR=$libdir
  while test "x$CX_LIBDIR" != `eval echo x$CX_LIBDIR`; do
    CX_LIBDIR=`eval echo $CX_LIBDIR`
  done
  CX_DATADIR=$datadir
  while test "x$CX_DATADIR" != `eval echo x$CX_DATADIR`; do
  CX_DATADIR=`eval echo $CX_DATADIR`
  done
  CX_LOCALEDIR=$localedir
  while test "x$CX_LOCALEDIR" != `eval echo x$CX_LOCALEDIR`; do
    CX_LOCALEDIR=`eval echo $CX_LOCALEDIR`
  done
  _cxk_ldflags=$LDFLAGS
  CX_RFLAG=
  AC_MSG_CHECKING([for linker runtime flag])
  LDFLAGS="$_cxk_ldflags -Wl,-rpath,/usr/lib"
  AC_LINK_IFELSE([AC_LANG_PROGRAM],[CX_RFLAG="-Wl,-rpath,"
  ],[
    LDFLAGS="$_cxk_ldflags -Wl,-rpath=/usr/lib"
    AC_LINK_IFELSE([AC_LANG_PROGRAM],[CX_RFLAG="-Wl,-rpath="
    ],[
      LDFLAGS="$_cxk_ldflags -R/usr/lib"
      AC_LINK_IFELSE([AC_LANG_PROGRAM],[CX_RFLAG="-R"
      ],[
        LDFLAGS="$_cxk_ldflags -Wl,-R/usr/lib"
        AC_LINK_IFELSE([AC_LANG_PROGRAM],[CX_RFLAG="-Wl,-R"])
      ])
    ])
  ])
  AS_IF([test -z "$CX_RFLAG"],[
    AC_MSG_RESULT([not possible])
  ],[
    AC_MSG_RESULT([$CX_RFLAG])
     CX_DLSEARCH_PATH="/lib /usr/lib"
  ])
  for _cxk_iterator in $CX_DLSEARCH_PATH; do
    CX_RPATHLIBDIR=$CX_RFLAG$CX_LIBDIR
    AS_IF([test $CX_LIBDIR = $_cxk_iterator],[
      CX_RPATHLIBDIR=
      break
    ])
  done
  LDFLAGS=$_cxk_ldflags
])

# ---------------------------------------------------------------------------- #

# CX_TRY_COMPILE([include],[body],[action_if_success],[action_if_failure])
# input : CPPFLAGS LIBS LDFLAGS

# ---------------------------------------------------------------------------- #

AC_DEFUN([CX_TRY_COMPILE],[
  for _cxl_iterator in $1; do
    _cxl_include="$_cxl_include#include <$_cxl_iterator>$as_nl"
  done
  AC_COMPILE_IFELSE([AC_LANG_PROGRAM([$_cxl_include],[$2])],[$3],[$4])
])  
# ---------------------------------------------------------------------------- #

# Skip Fortran checks

# ---------------------------------------------------------------------------- #

AU_DEFUN([AC_PROG_F77],[])
AU_DEFUN([AC_LIBTOOL_F77],[])

