/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CButton.h
  Info   : $Id: CButton.h,v 1.11 2012/05/06 18:57:36 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CButton_h
#define CButton_h

// C++X headers
#include <cxxx/CTopLevelWindow.h>

class CButton : public CWindow
{
	// Class CButton is a virtual base class for all buttons 
public:
	// Constructor
	CButton(CWindow *parent, unsigned msgid);

	// Destructor
	virtual ~CButton();

	// X event processing
	virtual void OnExpose(XExposeEvent& e) = 0;
	virtual void OnAccelerator(wchar_t key);

	// Enables / disables button
	virtual void Enable(bool enable);

	// Assigns a name to the button
	virtual void SetName(const std::string& name);

protected:
	// Makes changes visible
	virtual void UpdateState();

protected:
	std::wstring mName;
	wchar_t mAccelerator;
	CHotCharPos mHotCharPos;
};

#endif // CButton_h
