/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CColorSheet.h
  Info   : $Id: CColorSheet.h,v 1.14 2009/12/21 22:00:30 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2005 - 2009 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CColorSheet_h
#define CColorSheet_h

// C++X headers
#include <cxxx/CPushButton.h>


class CColorSheet : public CWindow
{
private:
	// Message IDs
	enum
	{
		IDFRAME = cxxx::msgid::MSGID_CColorSheet,
		IDTITLE,
		IDTOOL,
		IDBACK
	};

public:
	// Constructor
    CColorSheet(CWindow* parent);

	// X event processing
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnConfigure(XConfigureEvent& e);

	// C++X message processing
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);

	// Returns true if sheet can be closed
	bool DoOK();

protected:
	// Draw colored rectangle
	void DrawColorRect(int x, int y, unsigned w, unsigned h, CColor color, const std::string& s);

protected:
	CColor mFrameColor;
	CColor mTitleColor;
	CColor mTooltipColor;
	CColor mBackgroundColor;
	CPushButton mFrameChoose;
	CPushButton mTitleChoose;
	CPushButton mTooltipChoose;
	CPushButton mBackgroundChoose;
};

#endif // CColorSheet_h
