/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CCxxxAbout.cpp
  Info   : $Id: CCxxxAbout.cpp,v 1.36 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

// cxxx headers
#include <cxxx/CCxxxAbout.h>

// namespace declarations
using cxxx::cxMainWin;
using std::string;
using cxxx::lib::cxgettext;
using cxxx::cxIconv;

CCxxxAbout::CCxxxAbout(CWindow* parent)
: CTopLevelWindow(),
  mLabel1(this),
  mLabel2(this),
 mButton(this, IDOK)
{
	mIcon.Create(CIcon::CXXX, 48);
	SetCaption(_("About C++X", 24));
	Resize(300, 200);
	string text = _("This Software uses the C++X GUI Toolkit Library\nlibcxxx version", 27);
	text += " ";
	text += CXXX_VERSION;
	mLabel1.Resize(220, 60);
	mLabel1.SetText(text);
	mLabel1.Move(70, 10);
	string tmp = _("?LANGUAGE? translation\nCopyright (c) ?AUTHOR?", 26);
	unsigned ic = cxIconv.GetConverter("utf-8", "");
	text = cxIconv.Convert("Copyright © 2002 - 2012 Gerhard Kräuter", ic);
	if (!tmp.empty() && tmp[0] != '?') {
		text += "\n\n";
		text += tmp;
	}
	mLabel2.Resize(280, 90);
	mLabel2.SetText(text);
	mLabel2.Move(10, 70);
	mButton.SetName(_("&OK", 25));
	SetFocusWindow(&mButton);
	mButton.Move((GetWidth() - mButton.GetWidth()) / 2, 170);
	FixSize();
	TransientFor(parent->GetTopLevelWindow());
	mButton.Show();
	mLabel1.Show();
	mLabel2.Show();
}

/* virtual */ void CCxxxAbout::OnExpose(XExposeEvent& e)
{
	ClearArea(e);
	ClearArea(10, 10, mIcon.GetWidth(), mIcon.GetHeight());
	DrawIcon(10, 10, mIcon);
}

/* virtual */ void CCxxxAbout::OnMessage(unsigned msgid, TMessage type, unsigned value __attribute__ ((unused)))
{
	switch (msgid) {
	case IDOK:
		switch (type) {
		case MT_RELEASED:
		case MT_ACCELERATOR:
			OnQuit();
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
}

/* virtual */ void CCxxxAbout::OnQuit()
{
	mShutDown = true;
}
