/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CDnDAskDialog.h
  Info   : $Id: CDnDAskDialog.h,v 1.8 2008/02/26 20:47:30 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2003 - 2008 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CDnDAskDialog_h
#define CDnDAskDialog_h

// cxxx headers
#include <cxxx/CTopLevelWindow.h>
#include <cxxx/CRadioGroup.h>
#include <cxxx/CPushButton.h>

class CDnDAskDialog : public CTopLevelWindow
{
public:
	enum
	{
		// Message IDs
		IDCANCEL = cxxx::msgid::MSGID_CDnDAskDialog,
		IDOK,
		IDRADIO
	};

	// Constructor
	CDnDAskDialog(const std::vector<std::string>& list);

	// Destructor
	virtual ~CDnDAskDialog();

	// X event processing
	virtual void OnExpose(XExposeEvent& e);

	// C++X message processing
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);

	// Exit
	virtual void OnQuit();

protected:
	CRadioGroup mGroup;
	CPushButton mPushOK;
	CPushButton mPushCancel;
	std::vector<CRadioButton*> mButton;
};

#endif
