/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CDupFNDialog.h
  Info   : $Id: CDupFNDialog.h,v 1.14 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CDupFNDialog_h
#define CDupFNDialog_h

// C++X headers
#include <cxxx/CEdit.h>
#include <cxxx/CPushButton.h>
#include <cxxx/CRadioGroup.h>
#include <cxxx/CRadioButton.h>
#include <cxxx/CLabel.h>

class CDupFNDialog : public CTopLevelWindow
{
public:
	enum {
		// Message IDs
		IDRENAME = cxxx::msgid::MSGID_CDupFNDialog,
		IDSKIP,
		IDAUTOSKIP,
		IDOVER,
		IDOVERALL,
		IDOK,
		IDCANCEL
	};
public:
	// Constructor
	CDupFNDialog(const std::string& path, const std::string& name, bool overwrite);

	// X event processing
	virtual void OnExpose(XExposeEvent& e);
	virtual void OnFocus(bool in);
	virtual void OnKey(wchar_t key, unsigned state);

	// C++X message processing
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);

	// Exits the window
	virtual void OnQuit();

	// Returns the file name
	std::string GetName() const
	{
		return mEdit.GetText();
	}

private:
	CLabel mStatic;
	CEdit mEdit;
	CIcon mIcon;
	CRadioGroup mAction;
	CRadioButton mRename;
	CRadioButton mSkip;
	CRadioButton mAutoSkip;
	CRadioButton mOver;
	CRadioButton mOverAll;
	CPushButton mOK;
	CPushButton mCancel;
	std::string mPath;
	std::string mName;
};

#endif // CDupFNDialog_h
