/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CError.cpp
  Info   : $Id: CError.cpp,v 1.20 2012/02/26 17:49:11 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

// cxxx headers
#include <cxxx/CApplication.h>
#include <cxxx/CError.h>

// C++ headers
#include <iostream>
#include <sstream>

// Namespace declarations
using cxxx::cxApp;
using cxxx::lib::cxgettext;
using std::cerr;
using std::endl;


void CError::Info(CError& e)
{
	cerr << _("C++X: Info:\n", 41) << e.mText << endl;
	e.mCount = 0;
	e.mText.clear();
}

void CError::Warn(CError& e)
{
	cerr << _("C++X: Warning:\n", 42) << e.mText << endl;
	e.mCount = 0;
	e.mText.clear();
}

void CError::Error(CError& e)
{
	if (cxApp) {
		cxApp->Error(e.mText, false);
		e.mCount = 0;
		e.mText.clear();
	} else {
		cerr << _("C++X: Error:\n", 480) << e.mText << endl;
	}	
}

void CError::Fatal(CError& e)
{
	if (cxApp) {
		cxApp->Error(e.mText, true);
		e.mCount = 0;
		e.mText.clear();
	} else {
		cerr << _("C++X: Fatal:\n", 483) << e.mText << endl;
		exit (EXIT_FAILURE);
	}	
}
