/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CLabel.h
  Info   : $Id: CLabel.h,v 1.13 2012/06/26 08:05:52 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CLabel_h
#define CLabel_h

// C++X headers
#include <cxxx/CWindow.h>

class CLabel : public CWindow
{
public:
	// Constructor
	CLabel(CWindow* parent)
	: CWindow(parent)
	{
	}

	// X event processing
	virtual void OnExpose(XExposeEvent& e __attribute__ ((unused)))
	{
		if (mText.empty())	return ;
		DrawMultiLineString(0, 0, mWidth, CColor(TC_FRAME_TEXT), mText);
	}

	// Sets the text of the label
	void SetText(const std::string& text)
	{
		mText = text;
		Redraw();
	}

	// Returns the text of the label
	const std::string& GetText() const
	{
		return mText;
	}

protected:
	std::string mText;
};

#endif // CLabel_h
