/*----------------------------------------------------------------------------
  Project: cxxx <http://cxplorer.sourceforge.net>
  File   : CToolTip.h
  Info   : $Id: CToolTip.h,v 1.10 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/
  
/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef CToolTip_h
#define CToolTip_h

// cxxx headers
#include <cxxx/CWindow.h>


class CToolTip : public CWindow
{
private:
	enum
	{
		// Geometry
		X_BORDER = 4,
		Y_BORDER = 2
	};

public:
	// Constructor
	CToolTip(CWindow* parent, const std::string& text);

	// Destructor
	virtual ~CToolTip();

	// X event processing
	virtual void OnExpose(XExposeEvent& e);

	// Applies the application colors
	virtual void Recolor();

protected:
	Cursor mCursor;
	const std::wstring mText;
};

#endif // CToolTip_h
