/*----------------------------------------------------------------------------
  Project: libintlize <http://intlize.sourceforge.net>
  File   : i5e.hpp
  Info   : $Id: i5e.hpp,v 1.1.1.1 2010/03/09 19:31:56 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2010 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  software  is  provided  'as-is',  without  any  express  or  implied
  warranty.  In  no  event  will  the authors be held liable for any damages
  arising from the use of this software.

  Permission  is  granted  to  anyone  to use this software for any purpose,
  including  commercial  applications,  and  to alter it and redistribute it
  freely, subject to the following restrictions:

  1. The  origin  of  this software must not be misrepresented; you must not
     claim  that  you  wrote the original software. If you use this software
     in  a  product, an acknowledgment in the product documentation would be
     appreciated but is not required.
  2. Altered source versions must be plainly marked as such, and must not be
     misrepresented as being the original software.
  3. This notice may not be removed or altered from any source distribution.

----------------------------------------------------------------------------*/

#ifndef i5e_hpp
#define i5e_hpp

#define included_from_i5e_hpp
#include <intlize/i5e.h>

class i5e
{
public:
	i5e()
	{
		catalog = i5e_create_catalog();
	}
		
	~i5e()
	{
		i5e_free_catalog(catalog);
	}
		
	int open(const char* lang, const char* path, const char* charset)
	{
		return i5e_open(catalog, lang, path, charset);
	}

	void close()
	{
		i5e_close(catalog);
	}

	const char* error_text(int errnum)
	{
		return i5e_error_text(errnum);
	}
		
	const char* getmsg(int msgnum)
	{
		return i5e_getmsg(catalog, msgnum);
	}
		
	const char* get_id()
	{
		return i5e_getid(catalog);
	}
private:
	i5e_catalog_t catalog;
};

#endif
