/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CNewDialog.h
  Info   : $Id: CNewDialog.h,v 1.11 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CNewDialog_h
#define CNewDialog_h

// Application headers
#include "Xplorer.h"

// C++X headers
#include <cxxx/CPushButton.h>
#include <cxxx/CEdit.h>
#include <cxxx/CLabel.h>

// Forward declarations
class CXplorerFrame;

class CNewDialog : public CTopLevelWindow
{
private:
	enum
	{
		// Message IDs
		IDOK = xplorer::MSGID_CNewDialog,
		IDCANCEL,
		IDCLEAR
	};

public:
	enum
	{
		// Type
		TEXT_FILE,
		DIRECTORY
	};

public:
	// Constructor
	CNewDialog(CXplorerFrame* parent, unsigned type, const std::string& cwd);

	// X event processing
	virtual void OnFocus(bool in);
	virtual void OnKey(wchar_t key, unsigned state);

	// C++x message processing
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);
		
	// Exit
	virtual void OnQuit()
	{
		mShutDown = true;
	}

private:
	// Exit functions
	void OnOK();

private:
	CXplorerFrame* mFrameWin;
	CEdit mEdit;
	CLabel mStatic;
	CPushButton mButtonClear;
	CPushButton mButtonOK;
	CPushButton mButtonCancel;
	unsigned mType;
	std::string mCWD;
};

#endif // CNewDialog_h
