/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CPermissionSheet.h
  Info   : $Id: CPermissionSheet.h,v 1.11 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CPermissionSheet_h
#define CPermissionSheet_h

// C++X headers
#include <cxxx/CCheckButton.h>
#include <cxxx/CDropDownList.h>

// C headers
#include <sys/stat.h>

// F+orward declarations
class CXplorerList;
class CTapeArchive;

class CPermissionSheet : public CWindow
{
private:
    enum {
		// Permission bits
		RUSR,
		WUSR,
		XUSR,
		SUID,
		RGRP,
		WGRP,
		XGRP,
		SGID,
		ROTH,
		WOTH,
		XOTH,
		STICK,

		// Access types
		NOSTATUS = 0,
		NOACCESS,
		USERACCESS,
		ROOTACCESS
    };

public:
	// Constructor
	CPermissionSheet(CWindow* parent, CTapeArchive* arch, const std::string& path);

	// Destructor
	virtual ~CPermissionSheet();

	// X event processing
	virtual void OnExpose(XExposeEvent& e);

	// Prepares window for exit
	bool DoOK();

private:
	uid_t mUID;
	gid_t mGID;
	std::string mUserName;
	std::string mGroupName;
	std::string mPath;
	std::string mXAction;
	unsigned mAccess;
 	std::vector<CCheckButton*> mCheckButton;
	CDropDownList mGroupList;
	CDropDownList mUserList;
	struct stat mStatus;
};

#endif // CPermissionSheet_h
