/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CPreviewDialog.h
  Info   : $Id: CPreviewDialog.h,v 1.8 2012/05/11 16:04:29 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2005 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CPreviewDialog_h
#define CPreviewDialog_h

// Application headers
#include "Xplorer.h"

// C++X headers
#include <cxxx/CCheckButton.h>
#include <cxxx/CLabel.h>
#include <cxxx/CPushButton.h>
#include <cxxx/CRadioButton.h>
#include <cxxx/CTopLevelWindow.h>

class CPreviewDialog : public CTopLevelWindow
{
private:
	enum
	{
		// Message IDs
		IDDESKTOP = xplorer::MSGID_CPreviewDialog,
		IDBMP,
		IDGIF,
		IDJPEG,
		IDXPM,
		IDPNG,
		IDPPM,
		IDTIFF,
		IDSIZE10K,
		IDSIZE30K,
		IDSIZE100K,
		IDSIZE300K,
		IDSIZE1M,
		IDSIZEALL,
		IDOK,
		IDCANCEL
	};

public:
	// Constructor
	CPreviewDialog(unsigned flags);

	// X event processing
	virtual void OnExpose(XExposeEvent& e);

	// C++X message processing
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);

	// Exit function
	virtual void OnQuit()
	{
		mReturn = 0;
		mShutDown = true;
	}

private:
	CCheckButton mDesktop;
	CCheckButton mPPM;
	CCheckButton mXPM;
	CCheckButton mBMP;
#ifdef CXXX_HAS_GIF
	CCheckButton mGIF;
#endif // CXXX_HAS_GIF
#ifdef CXXX_HAS_JPEG
	CCheckButton mJPEG;
#endif // CXXX_HAS_JPEG
	CCheckButton mPNG;
#ifdef CXXX_HAS_TIFF
	CCheckButton mTIFF;
#endif // CXXX_HAS_TIFF
	CRadioGroup mFileSize;
	CRadioButton mSize10k;
	CRadioButton mSize30k;
	CRadioButton mSize100k;
	CRadioButton mSize300k;
	CRadioButton mSize1M;
	CRadioButton mSizeAll;
	CPushButton mOK;
	CPushButton mCancel;
	CLabel mStatic;
};

#endif // CPreviewDialog_h
