/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CRecentMenu.cpp
  Info   : $Id: CRecentMenu.cpp,v 1.9 2012/06/12 19:35:22 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2007 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

// Application headers
#include "CRecentMenu.h"

// C++ headers
#include <vector>

// Namespace declarations
using std::string;
using std::vector;

void CRecentMenu::SetDirectory(const string& dir)
{
	// Empty menu: Add entry
	if (mMenu.empty()) {
		Entry(mID, dir);
		return;
	}
	// The same directory is already the first: done
	if (mMenu.front().GetText() == dir) return;
	// Search for the directory in the menu, if found: place it on top
	for (vector<CMenuItem>::iterator i = mMenu.begin(); i != mMenu.end(); ++i) {
		if (i->GetText() == dir) {
			CMenuItem it = *i;
			mMenu.erase(i);
			mMenu.insert(mMenu.begin(), it);
			return;
		}
	}
	// Calculate the Message ID
	unsigned id;
	if (mMenu.size() < RECENTSIZE) id = mID + mMenu.size();
	else id = mMenu.back().GetMessageID();
	// Create a new entry
	// CMenuItem has a private Constructor; we have to use CMenu::Entry
	Entry(id, dir);
	CMenuItem it = mMenu.back();
	mMenu.erase(mMenu.end() - 1);
	mMenu.insert(mMenu.begin(), it);
	// Shrink menu to the apropiate size
	while (mMenu.size() > RECENTSIZE) mMenu.erase(mMenu.end() - 1);
}
