/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CRecentMenu.h
  Info   : $Id: CRecentMenu.h,v 1.8 2009/12/24 18:16:41 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2007 - 2009 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CRecentMenu_h
#define CRecentMenu_h

// C++ headers
#include <cassert>

// C++X headers
#include <cxxx/CMenuItem.h>

class CRecentMenu : public CMenu
{
public:
	enum
	{
		// Number of entries in this menue
		RECENTSIZE = 10
	};

public:
	// Constructor
	CRecentMenu(CWindow* owner, const std::string& name, unsigned id)
	: CMenu(owner, name),
	  mID(id)
	{
		assert(mID != 0);
	}

	// Makes dir the most recently visited directory
	void SetDirectory(const std::string& dir);

	// Returns the directory corresponding to id
	const std::string& GetDirectory(unsigned id) const
	{
		for (std::vector<CMenuItem>::const_iterator i = mMenu.begin(); i != mMenu.end(); ++i) {
			if (i->GetMessageID() == id) return i->GetText();
		}
		return cxxx::cxEmptyString;
	}

private:
	unsigned mID;
};

#endif // CRecentMenu_h
