/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CSortDialog.h
  Info   : $Id: CSortDialog.h,v 1.12 2009/02/13 19:35:53 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2009 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CSortDialog_h
#define CSortDialog_h

// Application headers
#include "Xplorer.h"

// C++X headers
#include <cxxx/CCheckButton.h>
#include <cxxx/CLabel.h>
#include <cxxx/CPushButton.h>
#include <cxxx/CRadioButton.h>
#include <cxxx/CTopLevelWindow.h>

class CSortDialog : public CTopLevelWindow
{
private:
	enum
	{
		// Message IDs
		IDDIRFIRST = xplorer::MSGID_CSortDialog,
		IDASCENDING,
		IDNAME,
		IDTIME,
		IDSIZE,
		IDTYPE,
		IDOK,
		IDDEFAULT,
		IDCANCEL
	};

public:
	enum
	{
		// Return value
		OK = cxxx::filesort::HIDDEN << 1
	};

public:
	// Constructor
	CSortDialog(unsigned flags);

	// X event processing
	virtual void OnExpose(XExposeEvent& e);

	// C++X message processing
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);

	// Exit function
	virtual void OnQuit()
	{
		mShutDown = true;
	}

private:
	CRadioGroup mSortGroup;
	CCheckButton mDirFirst;
	CCheckButton mAscending;
	CRadioButton mAlpha;
	CRadioButton mSize;
	CRadioButton mTime;
	CRadioButton mType;
	CLabel mStatic1;
	CLabel mStatic2;
	CPushButton mPushOK;
	CPushButton mPushDef;
	CPushButton mPushCancel;
};

#endif
