/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CTrashListControl.h
  Info   : $Id: CTrashListControl.h,v 1.7 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2007 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CTrashListControl_h
#define CTrashListControl_h

// Application headers
#include "Xplorer.h"

// C++X headers
#include <cxxx/CFileListControl.h>
#include <cxxx/CMenuItem.h>

class CTrashListControl : public CFileListControl
{
private:
	enum
	{
		// Message IDs
		IDEDIT_DEL = xplorer::MSGID_CTrashListControl,
		IDOPEN_WITH,
		IDLISTPROP
	};

public:
	// Constructor
	CTrashListControl(CWindow* parent, unsigned msgid)
	: CFileListControl(parent, msgid),
	  mContext(reinterpret_cast<CWindow*>(GetTopLevelWindow()), "")
	{
		SetSortKey(cxxx::filesort::NAME | cxxx::filesort::ASCENDING);
		CreateContextMenu();
	}

	// Draws the item with index idx
	virtual void DrawItem(unsigned idx);

	// Opens a context menu
	virtual void OnContext()
	{
		Popup(mContext);
	}

	// Opens a property dialog
	void OnProperties();

protected:
	// Adds an item to the list
	virtual void Append(const std::string& path, const std::string& name);

	// Creates a context menu
	void CreateContextMenu();

protected:	
	CMenu mContext;
};

#endif // CTrashListControl_h
