/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CXplorerAbout.cpp
  Info   : $Id: CXplorerAbout.cpp,v 1.31 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

// Application headers
#include "CXplorerAbout.h"

// Namespace declarations
using cxxx::cxMainWin;
using std::string;
using cxxx::cxgettext;
using cxxx::cxIconv;

CXplorerAbout::CXplorerAbout(CWindow* parent)
: CTopLevelWindow(),
  mLabel1(this),
  mLabel2(this),
  mButton(this, IDOK)
{
	Resize(300, 200);
	mIcon.Create(CIcon::APP, 48);
	SetCaption(_("About Xplorer", 125));
	string text = _("Xplorer file manager\nxplorer version", 123);
	text += " ";
	text += xplorer_VERSION;
	mLabel1.Resize(220, 60);
	mLabel1.SetText(text);
	mLabel1.Move(70, 10);
	string tmp = _("?LANGUAGE? translation\nCopyright (c) ?AUTHOR?", 124);
	unsigned ic = cxIconv.GetConverter("utf-8", "");
	text = cxIconv.Convert("Copyright © 2002 - 2012 Gerhard Kräuter", ic);
	if (!tmp.empty() && tmp[0] != '?') {
		text += "\n\n";
		text += tmp;
	}
	mLabel2.Resize(280, 90);
	mLabel2.SetText(text);
	mLabel2.Move(10, 70);
	mButton.SetName(_("&OK", 3));
	SetFocusWindow(&mButton);
	mButton.Move((GetWidth() - mButton.GetWidth()) / 2, 170);
	FixSize();
	TransientFor(parent->GetTopLevelWindow());
	mButton.Show();
	mLabel1.Show();
	mLabel2.Show();
}

/* virtual */ void CXplorerAbout::OnExpose(XExposeEvent& e)
{
	ClearArea(e);
	ClearArea(10, 10, mIcon.GetWidth(), mIcon.GetHeight());
	DrawIcon(10, 10, mIcon);
}

/* virtual */ void CXplorerAbout::OnMessage(unsigned msgid, TMessage type, unsigned value __attribute__ ((unused)))
{
	switch (msgid) {
	case IDOK:
		switch (type) {
		case MT_RELEASED:
		case MT_ACCELERATOR:
			OnQuit();
			break;
		default:
			break;
		}
		break;
	default:
		break;
	}
}
