/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CXplorerAbout.h
  Info   : $Id: CXplorerAbout.h,v 1.10 2012/05/06 18:57:37 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2006 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CXplorerAbout_h
#define CXplorerAbout_h

// Application headers
#include "Xplorer.h"

// C++X headers
#include <cxxx/CLabel.h>
#include <cxxx/CPushButton.h>

class CXplorerAbout : public CTopLevelWindow
{
private:
	enum
	{
		// Message IDs
		IDOK = xplorer::MSGID_CXplorerAbout
	};

public:
	// Constructor
	CXplorerAbout(CWindow* parent);

	// X event processing
	virtual void OnExpose(XExposeEvent& e);

	// C++X message processing
	virtual void OnMessage(unsigned msgid, TMessage type, unsigned value);

	// Exit function
	virtual void OnQuit()
	{
		mShutDown = true;
	}

private:
	CIcon mIcon;
	CLabel mLabel1;
	CLabel mLabel2;
	CPushButton mButton;
};

#endif // CXplorerAbout_h
