/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CXplorerMenu.h
  Info   : $Id: CXplorerMenu.h,v 1.16 2012/08/06 17:36:40 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef CXplorerMenu_h
#define CXplorerMenu_h

// Application headers
#include "CRecentMenu.h"

// C++X headers
#include <cxxx/CMenuBar.h>

class CXplorerMenu : public CMenuBar
{
public:
	// Constructor
	CXplorerMenu(CWindow* parent);

	// Recently visited files interface
	void SetDirectory(const std::string& dir)
	{
		mMnuFileRecent.SetDirectory(dir);
	}
	
	void SetDirList(const std::string& list);

	std::string GetDirList()
	{
		std::string ret;
		if (mMnuFileRecent.GetSize() > 0) ret = mMnuFileRecent[0].GetText();
		for (unsigned i = 1; i < mMnuFileRecent.GetSize(); ++i) {
			ret += ":";
			ret += mMnuFileRecent[i].GetText();
		}
		return ret;
	}

	std::string GetDirectory(unsigned id)
	{
		return mMnuFileRecent.GetDirectory(id);
	}

private:
	CMenu mMnuFile;
	CMenu mMnuFileNew;
	CRecentMenu mMnuFileRecent;
	CMenu mMnuEdit;
	CMenu mMnuView;
	CMenu mMnuTools;
	CMenu mMnuHelp;
};

#endif // CXplorerMenu_h
