/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : CXplorerTool.cpp
  Info   : $Id: CXplorerTool.cpp,v 1.17 2012/06/26 08:05:52 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2002 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

// cxxx headers
#include <cxxx/CToolButton.h>

// application headers
#include "Xplorer.h"
#include "CXplorerFrame.h"
#include "CXplorerTool.h"

// namespace declarations
using cxxx::cxgettext;

CXplorerTool::CXplorerTool(CWindow* parent)
: CWindow(parent),
  mUp(this, CXplorerFrame::IDNAV_UP, CIcon::UP, _("Up", 64)),
  mBack(this, CXplorerFrame::IDNAV_BACK, CIcon::BACK, _("Back", 65)),
  mForward(this, CXplorerFrame::IDNAV_FORWARD, CIcon::FORWARD, _("Forward", 66)),
  mHome(this, CXplorerFrame::IDNAV_HOME, CIcon::GOHOME, _("Enter your Home Directory", 114)),
  mRefresh(this, CXplorerFrame::IDVIEW_REFRESH, CIcon::RELOAD, _("Refresh", 115)),
  mCut(this, CXplorerFrame::IDEDIT_CUT, CIcon::EDITCUT, _("Cut", 69)),
  mCopy(this, CXplorerFrame::IDEDIT_COPY, CIcon::EDITCOPY, _("Copy", 70)),
  mPaste(this, CXplorerFrame::IDEDIT_PASTE, CIcon::EDITPASTE, _("Paste", 71))
{
	if (cxxx::cxRTL) {
		mBack.SetIcon(CIcon::FORWARD);
		mForward.SetIcon(CIcon::BACK);
	}
}

/* virtual */ void CXplorerTool::OnConfigure(XConfigureEvent& e __attribute__ ((unused)))
{
	mUp.Move(10, 2);
	mBack.Move(32, 2);
	mForward.Move(54, 2);
	mHome.Move(86, 2);
	mRefresh.Move(118, 2);
	mCut.Move(150, 2);
	mCopy.Move(172, 2);
	mPaste.Move(194, 2);
}
