/*----------------------------------------------------------------------------
  Project: Xplorer <http://cxplorer.sourceforge.net>
  File   : Xplorer.h
  Info   : $Id: Xplorer.h,v 1.20 2012/03/26 16:57:44 gkraeuter Exp $
----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
  Copyright © 2003 - 2012 Gerhard Kräuter <gkraeuter@users.sourceforge.net>

  This  program  is  free software: you can redistribute it and/or modify it
  under  the  terms  of  the  GNU General Public License as published by the
  Free Software Foundation,  either  version  3  of the License, or (at your
  option) any later version.

  This  program  is  distributed  in  the  hope  that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or  FITNESS FOR A PARTICULAR PURPOSE.  See the  GNU General Public License
  for more details.

  You  should  have  received a copy of the GNU General Public License along
  with this program. If not, see  <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------*/

#ifndef Xplorer_h
#define Xplorer_h

// cxxx headers
#include <cxxx/Cxxx.h>

// configuration header
#include "config.h"

namespace xplorer
{
	enum
	{
		MSGID_CNewDialog		= cxxx::msgid::MSGID_Last,
		MSGID_CPermissionSheet	= MSGID_CNewDialog 		 + cxxx::msgid::MSGID_Step,
		MSGID_CPropertyDialog	= MSGID_CPermissionSheet + cxxx::msgid::MSGID_Step,
		MSGID_CSortDialog		= MSGID_CPropertyDialog  + cxxx::msgid::MSGID_Step,
		MSGID_CXplorerFrame		= MSGID_CSortDialog		 + cxxx::msgid::MSGID_Step,
		MSGID_CXplorerAbout		= MSGID_CXplorerFrame	 + cxxx::msgid::MSGID_Step,
		MSGID_CFileAssoc		= MSGID_CXplorerAbout	 + cxxx::msgid::MSGID_Step,
		MSGID_CXplorerList		= MSGID_CFileAssoc		 + cxxx::msgid::MSGID_Step,
		MSGID_CPreviewDialog	= MSGID_CXplorerList	 + cxxx::msgid::MSGID_Step,
		MSGID_CUntrashDialog	= MSGID_CPreviewDialog 	 + cxxx::msgid::MSGID_Step,
		MSGID_CTrashListControl = MSGID_CUntrashDialog 	 + cxxx::msgid::MSGID_Step,
		MSGID_CTermConfig		= MSGID_CTrashListControl+ cxxx::msgid::MSGID_Step
	};

	enum {
		LIB,
		APP,
		BOTH
	};

	void IntlInit(unsigned which);
}

#endif // Xplorer_h
